Subject: Re: [BUG][PATCH] Fix race condition about network device name allocation

From: Stephen Hemminger <[email-masked]>
Date: Mon, 14 May 2007 08:41:57 -0700

On Mon, 14 May 2007 10:33:01 +0900
Kenji Kaneshige <[email-masked]> wrote:

> Hi Stephen,
> 
> Thank you for comments. I'll try your patch.
> 
> I have one concern about your patch, though I don't know very much 
> about netdev codes.
> 
> @@ -3411,6 +3410,9 @@ void unregister_netdevice(struct net_dev
> >  	/* Notifier chain MUST detach us from master device. */
> >  	BUG_TRAP(!dev->master);
> >  
> > +	/* Remove entries from sysfs */
> > +	netdev_unregister_sysfs(dev);
> > +
> >  	/* Finish processing unregister after unlock */
> >  	net_set_todo(dev);
> >  
> 
> With your patch, the netdev_unregister_sysfs() will be called
> earlier than now. Does it have no side effect? I'm worrying 
> about if there are somebody that depend on sysfs entry until
> net_run_todo() is called.

The unregister_sysfs() removes the entry in /sys/class/net and then
decrements the reference count. When ref count goes to zero, the kobject_release
callback gets called and which does kfree(). 

Changing the shutdown order makes the /sys/class/net entry disappear
sooner. In order to prevent the free from happening until after all the dev_put()
calls have happened, the reference count for the kobject needs to be increased.